NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Assemblies::AddComponentBuilder Class Reference

Represents a builder class that performs add existing component operation in current context. More...

Inheritance diagram for NXOpen::Assemblies::AddComponentBuilder:
NXOpen::Builder NXOpen::IAttributeSourceObjectBuilder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  LocationType { LocationTypeSnap, LocationTypeWorkPartAbsolute, LocationTypeDisplayedPartAbsolute, LocationTypeDisplayedPartWCS }
 Represents initial location type that can be present during add component. More...
 

Public Member Functions

virtual NXOpen::ErrorListAutoAssignAttributes (const std::vector< NXOpen::NXObject * > &objects)
 Auto assigns the attributes for a given array of objects and returns an array of objects that failed to auto assign. More...
 
virtual NXOpen::ErrorListAutoAssignAttributesWithNamingPattern (const std::vector< NXOpen::NXObject * > &objects, const std::vector< NXOpen::NXObject * > &properties)
 Auto assigns the attributes for a given object and returns an array of objects that failed to auto assign. More...
 
NXString ComponentName ()
 Returns the component name for added components. More...
 
virtual NXOpen::NXObjectCreateAttributeTitleToNamingPatternMap (std::vector< NXString > &attributeTitles, std::vector< NXString > &titlePatterns)
 Creates a map object of attribute titles to their corresponding naming pattern. More...
 
NXString DesignElementType ()
 Returns the type of a add component
Created in NX12.0.0. More...
 
NXOpen::FileNewFileNewDescriptor ()
 Returns the file new descriptor to identify an added component in 4GD
Created in NX12.0.0. More...
 
void GetAllProductInterfaceObjects (std::vector< NXOpen::Assemblies::ProductInterface::InterfaceObject * > &productInterfaceObjects)
 Returns all product interface objects available, one of these can be used as component anchor
Created in NX12.0.0. More...
 
NXOpen::Assemblies::ProductInterface::InterfaceObjectGetComponentAnchor ()
 Returns the component anchor used for adding component. More...
 
int GetCount ()
 Gets the number of components to be added. More...
 
void GetInitialLocationAndOrientation (NXOpen::Point **initialLocation, NXOpen::CoordinateSystem **initialOrientation)
 Returns the location and orientation used for adding component
Created in NX12.0.0. More...
 
NXOpen::Assemblies::AddComponentBuilder::LocationType GetInitialLocationType ()
 Get the initial location type during add component. More...
 
bool GetKeepConstraintsOption ()
 Gets the keep constraints option for added components. More...
 
void GetLogicalObjects (std::vector< NXOpen::PDM::LogicalObject * > &logicalObjects)
 Returns the pre-creation objects
Created in NX12.0.0. More...
 
void GetLogicalObjectsHavingUnassignedRequiredAttributes (std::vector< NXOpen::PDM::LogicalObject * > &logicalObjects)
 Returns the pre-creation objects which have unassign required attributes
Created in NX12.0.0. More...
 
NXOpen::ErrorListGetOperationFailures ()
 Returns add component operation failures. More...
 
void GetPartsToAdd (std::vector< NXOpen::BasePart * > &partsToUse)
 Returns the parts to be used for adding components
Created in NX12.0.0. More...
 
bool GetScatterOption ()
 Gets the scatter option for added components. More...
 
int Layer ()
 Returns the layer for added components. More...
 
void OrientToWCS ()
 Orient added components to the WCS
Created in NX12.0.0. More...
 
NXString ReferenceSet ()
 Returns the reference set for added components. More...
 
void RemoveAddedComponents ()
 Removes the components added through add component
Created in NX12.0.0. More...
 
void ResetToSnapped ()
 Resets the component to snapped position and orientation
Created in NX12.0.0. More...
 
void ReverseZDirection ()
 Reverse the Z direction of added components
Created in NX12.0.0. More...
 
void RotateAlongZDirection ()
 Rotate added components along Z direction by 90 degrees
Created in NX12.0.0. More...
 
void SetComponentAnchor (NXOpen::Assemblies::ProductInterface::InterfaceObject *componentAnchor)
 Sets the component anchor to be used for adding component
Created in NX12.0.0. More...
 
void SetComponentName (const NXString &componentName)
 Sets the component name for added components. More...
 
void SetComponentName (const char *componentName)
 Sets the component name for added components. More...
 
void SetCount (int count)
 Sets the number of components to be added. More...
 
void SetDesignElementType (const NXString &deType)
 Sets the type of a add component
Created in NX12.0.0. More...
 
void SetDesignElementType (const char *deType)
 Sets the type of a add component
Created in NX12.0.0. More...
 
void SetInitialLocationAndOrientation (NXOpen::Point *initialLocation, NXOpen::CoordinateSystem *initialOrientation)
 Sets the location and orientation to be used for adding component. More...
 
void SetInitialLocationAndOrientation (const NXOpen::Point3d &point, const NXOpen::Matrix3x3 &orientation)
 Sets the location and orientation to be used for add component. More...
 
void SetInitialLocationType (NXOpen::Assemblies::AddComponentBuilder::LocationType locationType)
 Set the initial location type during add component. More...
 
void SetKeepConstraintsOption (bool keepConstraintsOption)
 Sets the keep constraints option for added components. More...
 
void SetLayer (int layer)
 Sets the layer for added components. More...
 
void SetPartsToAdd (const std::vector< NXOpen::BasePart * > &partsToUse)
 Sets the parts to be used for adding components
Created in NX12.0.0. More...
 
void SetReferenceSet (const NXString &referenceSet)
 Sets the reference set for added components. More...
 
void SetReferenceSet (const char *referenceSet)
 Sets the reference set for added components. More...
 
void SetScatterOption (bool scatterOption)
 Sets the scatter option for added components. More...
 
void SetSynchDisplayProperties (bool synchDisplayProperties)
 Sets the option to synchronize display properties with the component to be added
Created in NX12.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a builder class that performs add existing component operation in current context.

Context can be Assembly or 4GD.
To create a new instance of this class, use NXOpen::Assemblies::AssemblyManager::CreateAddComponentBuilder

Created in NX12.0.0.

Member Enumeration Documentation

Represents initial location type that can be present during add component.

Enumerator
LocationTypeSnap 

Snap as initial location type.

LocationTypeWorkPartAbsolute 

Absolute of work part as initial location type.

LocationTypeDisplayedPartAbsolute 

Absolute of displayed part as initial location type.

LocationTypeDisplayedPartWCS 

WCS as initial location type.

Member Function Documentation

virtual NXOpen::ErrorList* NXOpen::Assemblies::AddComponentBuilder::AutoAssignAttributes ( const std::vector< NXOpen::NXObject * > &  objects)
virtual

Auto assigns the attributes for a given array of objects and returns an array of objects that failed to auto assign.

Returns

Created in NX8.5.0.

License requirements : None
Parameters
objectsobjects

Implements NXOpen::IAttributeSourceObjectBuilder.

virtual NXOpen::ErrorList* NXOpen::Assemblies::AddComponentBuilder::AutoAssignAttributesWithNamingPattern ( const std::vector< NXOpen::NXObject * > &  objects,
const std::vector< NXOpen::NXObject * > &  properties 
)
virtual

Auto assigns the attributes for a given object and returns an array of objects that failed to auto assign.

properties needs to be created using CreateAttributeTitleToNamingPatternMap

Returns

Created in NX12.0.0.

License requirements : None
Parameters
objectsobjects
propertiesproperties

Implements NXOpen::IAttributeSourceObjectBuilder.

NXString NXOpen::Assemblies::AddComponentBuilder::ComponentName ( )

Returns the component name for added components.


Created in NX12.0.0.

License requirements : None

virtual NXOpen::NXObject* NXOpen::Assemblies::AddComponentBuilder::CreateAttributeTitleToNamingPatternMap ( std::vector< NXString > &  attributeTitles,
std::vector< NXString > &  titlePatterns 
)
virtual

Creates a map object of attribute titles to their corresponding naming pattern.

Returns

Created in NX12.0.0.

License requirements : None
Parameters
attributeTitlesattributetitles
titlePatternstitlepatterns

Implements NXOpen::IAttributeSourceObjectBuilder.

NXString NXOpen::Assemblies::AddComponentBuilder::DesignElementType ( )

Returns the type of a add component
Created in NX12.0.0.



License requirements : None

NXOpen::FileNew* NXOpen::Assemblies::AddComponentBuilder::FileNewDescriptor ( )

Returns the file new descriptor to identify an added component in 4GD
Created in NX12.0.0.



License requirements : None

void NXOpen::Assemblies::AddComponentBuilder::GetAllProductInterfaceObjects ( std::vector< NXOpen::Assemblies::ProductInterface::InterfaceObject * > &  productInterfaceObjects)

Returns all product interface objects available, one of these can be used as component anchor
Created in NX12.0.0.



License requirements : None

Parameters
productInterfaceObjectsproductinterfaceobjects
NXOpen::Assemblies::ProductInterface::InterfaceObject* NXOpen::Assemblies::AddComponentBuilder::GetComponentAnchor ( )

Returns the component anchor used for adding component.

Returns

Created in NX12.0.0.

License requirements : None
int NXOpen::Assemblies::AddComponentBuilder::GetCount ( )

Gets the number of components to be added.

Returns

Created in NX12.0.0.

License requirements : None
void NXOpen::Assemblies::AddComponentBuilder::GetInitialLocationAndOrientation ( NXOpen::Point **  initialLocation,
NXOpen::CoordinateSystem **  initialOrientation 
)

Returns the location and orientation used for adding component
Created in NX12.0.0.



License requirements : None

Parameters
initialLocationinitiallocation
initialOrientationinitialorientation
NXOpen::Assemblies::AddComponentBuilder::LocationType NXOpen::Assemblies::AddComponentBuilder::GetInitialLocationType ( )

Get the initial location type during add component.

Returns

Created in NX12.0.0.

License requirements : None
bool NXOpen::Assemblies::AddComponentBuilder::GetKeepConstraintsOption ( )

Gets the keep constraints option for added components.

Returns

Created in NX12.0.0.

License requirements : None
void NXOpen::Assemblies::AddComponentBuilder::GetLogicalObjects ( std::vector< NXOpen::PDM::LogicalObject * > &  logicalObjects)

Returns the pre-creation objects
Created in NX12.0.0.



License requirements : None

Parameters
logicalObjectslogicalobjects
void NXOpen::Assemblies::AddComponentBuilder::GetLogicalObjectsHavingUnassignedRequiredAttributes ( std::vector< NXOpen::PDM::LogicalObject * > &  logicalObjects)

Returns the pre-creation objects which have unassign required attributes
Created in NX12.0.0.



License requirements : None

Parameters
logicalObjectslogicalobjects
NXOpen::ErrorList* NXOpen::Assemblies::AddComponentBuilder::GetOperationFailures ( )

Returns add component operation failures.

Returns

Created in NX12.0.0.

License requirements : None
void NXOpen::Assemblies::AddComponentBuilder::GetPartsToAdd ( std::vector< NXOpen::BasePart * > &  partsToUse)

Returns the parts to be used for adding components
Created in NX12.0.0.



License requirements : None

Parameters
partsToUsepartstouse
bool NXOpen::Assemblies::AddComponentBuilder::GetScatterOption ( )

Gets the scatter option for added components.

Returns

Created in NX12.0.0.

License requirements : None
int NXOpen::Assemblies::AddComponentBuilder::Layer ( )

Returns the layer for added components.


Created in NX12.0.0.

License requirements : None

void NXOpen::Assemblies::AddComponentBuilder::OrientToWCS ( )

Orient added components to the WCS
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

NXString NXOpen::Assemblies::AddComponentBuilder::ReferenceSet ( )

Returns the reference set for added components.


Created in NX12.0.0.

License requirements : None

void NXOpen::Assemblies::AddComponentBuilder::RemoveAddedComponents ( )

Removes the components added through add component
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

void NXOpen::Assemblies::AddComponentBuilder::ResetToSnapped ( )

Resets the component to snapped position and orientation
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

void NXOpen::Assemblies::AddComponentBuilder::ReverseZDirection ( )

Reverse the Z direction of added components
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

void NXOpen::Assemblies::AddComponentBuilder::RotateAlongZDirection ( )

Rotate added components along Z direction by 90 degrees
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

void NXOpen::Assemblies::AddComponentBuilder::SetComponentAnchor ( NXOpen::Assemblies::ProductInterface::InterfaceObject componentAnchor)

Sets the component anchor to be used for adding component
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
componentAnchorcomponentanchor
void NXOpen::Assemblies::AddComponentBuilder::SetComponentName ( const NXString componentName)

Sets the component name for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
componentNamecomponentname
void NXOpen::Assemblies::AddComponentBuilder::SetComponentName ( const char *  componentName)

Sets the component name for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
componentNamecomponentname
void NXOpen::Assemblies::AddComponentBuilder::SetCount ( int  count)

Sets the number of components to be added.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
countcount
void NXOpen::Assemblies::AddComponentBuilder::SetDesignElementType ( const NXString deType)

Sets the type of a add component
Created in NX12.0.0.



License requirements : nx_4gd_integration ("4th Generation Design")

Parameters
deTypedetype
void NXOpen::Assemblies::AddComponentBuilder::SetDesignElementType ( const char *  deType)

Sets the type of a add component
Created in NX12.0.0.



License requirements : nx_4gd_integration ("4th Generation Design")

Parameters
deTypedetype
void NXOpen::Assemblies::AddComponentBuilder::SetInitialLocationAndOrientation ( NXOpen::Point initialLocation,
NXOpen::CoordinateSystem initialOrientation 
)

Sets the location and orientation to be used for adding component.

Orientation is optional and user can pass NULL.
Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
initialLocationinitiallocation
initialOrientationinitialorientation
void NXOpen::Assemblies::AddComponentBuilder::SetInitialLocationAndOrientation ( const NXOpen::Point3d point,
const NXOpen::Matrix3x3 orientation 
)

Sets the location and orientation to be used for add component.

Orientation is optional and user can pass NULL.
Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
pointpoint
orientationorientation
void NXOpen::Assemblies::AddComponentBuilder::SetInitialLocationType ( NXOpen::Assemblies::AddComponentBuilder::LocationType  locationType)

Set the initial location type during add component.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
locationTypelocationtype
void NXOpen::Assemblies::AddComponentBuilder::SetKeepConstraintsOption ( bool  keepConstraintsOption)

Sets the keep constraints option for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
keepConstraintsOptionkeepconstraintsoption
void NXOpen::Assemblies::AddComponentBuilder::SetLayer ( int  layer)

Sets the layer for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
layerlayer
void NXOpen::Assemblies::AddComponentBuilder::SetPartsToAdd ( const std::vector< NXOpen::BasePart * > &  partsToUse)

Sets the parts to be used for adding components
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
partsToUsepartstouse
void NXOpen::Assemblies::AddComponentBuilder::SetReferenceSet ( const NXString referenceSet)

Sets the reference set for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
referenceSetreferenceset
void NXOpen::Assemblies::AddComponentBuilder::SetReferenceSet ( const char *  referenceSet)

Sets the reference set for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
referenceSetreferenceset
void NXOpen::Assemblies::AddComponentBuilder::SetScatterOption ( bool  scatterOption)

Sets the scatter option for added components.


Created in NX12.0.0.

License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
scatterOptionscatteroption
void NXOpen::Assemblies::AddComponentBuilder::SetSynchDisplayProperties ( bool  synchDisplayProperties)

Sets the option to synchronize display properties with the component to be added
Created in NX12.0.0.



License requirements : assemblies ("ASSEMBLIES MODULE")

Parameters
synchDisplayPropertiessynchdisplayproperties

The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.